<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: include/print.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">print.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;sstream&gt;</code><br />
<code>#include &quot;<a class="el" href="print__atom_8h_source.html">print_atom.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="print__concepts_8h_source.html">print_concepts.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="print__list_8h_source.html">print_list.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="print__options_8h_source.html">print_options.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for print.h:</div>
<div class="dyncontent">
<div class="center"><img src="print_8h__incl.png" border="0" usemap="#include_2print_8h" alt=""/></div>
<map name="include_2print_8h" id="include_2print_8h">
<area shape="rect" title=" " alt="" coords="277,5,392,32"/>
<area shape="rect" title=" " alt="" coords="5,229,80,256"/>
<area shape="rect" href="print__atom_8h.html" title=" " alt="" coords="282,80,387,107"/>
<area shape="rect" href="print__options_8h.html" title=" " alt="" coords="202,155,321,181"/>
<area shape="rect" href="print__concepts_8h.html" title=" " alt="" coords="475,155,605,181"/>
<area shape="rect" href="print__list_8h.html" title=" " alt="" coords="412,80,503,107"/>
<area shape="rect" title=" " alt="" coords="392,304,451,331"/>
<area shape="rect" title=" " alt="" coords="257,229,333,256"/>
<area shape="rect" title=" " alt="" coords="104,229,181,256"/>
<area shape="rect" href="terminalcolors_8h.html" title=" " alt="" coords="357,229,485,256"/>
<area shape="rect" title=" " alt="" coords="613,304,693,331"/>
<area shape="rect" title=" " alt="" coords="560,229,640,256"/>
<area shape="rect" title=" " alt="" coords="664,229,755,256"/>
</map>
</div>
</div><div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="print_8h__dep__incl.png" border="0" usemap="#include_2print_8hdep" alt=""/></div>
<map name="include_2print_8hdep" id="include_2print_8hdep">
<area shape="rect" title=" " alt="" coords="137,5,252,32"/>
<area shape="rect" href="print__ostream_8h.html" title=" " alt="" coords="5,80,181,107"/>
<area shape="rect" href="print__shortcuts_8h.html" title=" " alt="" coords="206,80,389,107"/>
</map>
</div>
</div>
<p><a href="print_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:afe9466890a34c5498386a55281bf30a7"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:afe9466890a34c5498386a55281bf30a7"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a> (std::ostream &amp;out, const PrintOptions &amp;options, const T &amp;t)</td></tr>
<tr class="memdesc:afe9466890a34c5498386a55281bf30a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints a single object. Default for objects that are not lists ("atoms").  <a href="print_8h.html#afe9466890a34c5498386a55281bf30a7">More...</a><br /></td></tr>
<tr class="separator:afe9466890a34c5498386a55281bf30a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a84aa02fb20f80f38d0b6b7418094c9a3"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:a84aa02fb20f80f38d0b6b7418094c9a3"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print_8h.html#a84aa02fb20f80f38d0b6b7418094c9a3">print_recursive</a> (std::ostream &amp;out, const PrintOptions &amp;options, const T &amp;t)</td></tr>
<tr class="memdesc:a84aa02fb20f80f38d0b6b7418094c9a3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints last element if only one left after recursion.  <a href="print_8h.html#a84aa02fb20f80f38d0b6b7418094c9a3">More...</a><br /></td></tr>
<tr class="separator:a84aa02fb20f80f38d0b6b7418094c9a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa6b8a6af7bd70b1b05875ba379ede13c"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:aa6b8a6af7bd70b1b05875ba379ede13c"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print_8h.html#aa6b8a6af7bd70b1b05875ba379ede13c">print_recursive</a> (std::ostream &amp;out, const PrintOptions &amp;options, const T &amp;t, const PrintOptions &amp;)</td></tr>
<tr class="memdesc:aa6b8a6af7bd70b1b05875ba379ede13c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html" title="Sets the options of the print() function.">PrintOptions</a>&amp; from args, and prints last element.  <a href="print_8h.html#aa6b8a6af7bd70b1b05875ba379ede13c">More...</a><br /></td></tr>
<tr class="separator:aa6b8a6af7bd70b1b05875ba379ede13c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a36591a53d09fc0c1ed0b14ce88e3df1a"><td class="memTemplParams" colspan="2">template&lt;class T , class ... Args&gt; </td></tr>
<tr class="memitem:a36591a53d09fc0c1ed0b14ce88e3df1a"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print_8h.html#a36591a53d09fc0c1ed0b14ce88e3df1a">print_recursive</a> (std::ostream &amp;out, const PrintOptions &amp;options, const T &amp;t, const Args &amp;...args)</td></tr>
<tr class="memdesc:a36591a53d09fc0c1ed0b14ce88e3df1a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints first argument.  <a href="print_8h.html#a36591a53d09fc0c1ed0b14ce88e3df1a">More...</a><br /></td></tr>
<tr class="separator:a36591a53d09fc0c1ed0b14ce88e3df1a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad5337a574ea6c177f4ffb967393a3eb8"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:ad5337a574ea6c177f4ffb967393a3eb8"><td class="memTemplItemLeft" align="right" valign="top">PrintOptions&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print_8h.html#ad5337a574ea6c177f4ffb967393a3eb8">get_options</a> (const T &amp;)</td></tr>
<tr class="memdesc:ad5337a574ea6c177f4ffb967393a3eb8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded function; if T&amp; is not <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html" title="Sets the options of the print() function.">PrintOptions</a>&amp; return default options.  <a href="print_8h.html#ad5337a574ea6c177f4ffb967393a3eb8">More...</a><br /></td></tr>
<tr class="separator:ad5337a574ea6c177f4ffb967393a3eb8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa03606f937c8c5755f00f9516cf21a60"><td class="memItemLeft" align="right" valign="top">PrintOptions&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="print_8h.html#aa03606f937c8c5755f00f9516cf21a60">get_options</a> (const PrintOptions &amp;options)</td></tr>
<tr class="memdesc:aa03606f937c8c5755f00f9516cf21a60"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded function; if T&amp; is PrintOptios&amp; returns them.  <a href="print_8h.html#aa03606f937c8c5755f00f9516cf21a60">More...</a><br /></td></tr>
<tr class="separator:aa03606f937c8c5755f00f9516cf21a60"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeee5a1be79dd7c9cb87c7f6aa842a89a"><td class="memTemplParams" colspan="2">template&lt;class ... Args&gt; </td></tr>
<tr class="memitem:aeee5a1be79dd7c9cb87c7f6aa842a89a"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a> (const Args &amp;...args)</td></tr>
<tr class="memdesc:aeee5a1be79dd7c9cb87c7f6aa842a89a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints any object.  <a href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">More...</a><br /></td></tr>
<tr class="separator:aeee5a1be79dd7c9cb87c7f6aa842a89a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Defines the main print function and helper functions. </p>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="aa03606f937c8c5755f00f9516cf21a60"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa03606f937c8c5755f00f9516cf21a60">&#9670;&nbsp;</a></span>get_options() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">PrintOptions cpp20print::printing::detail::get_options </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname"><em>options</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Overloaded function; if T&amp; is PrintOptios&amp; returns them. </p>

</div>
</div>
<a id="ad5337a574ea6c177f4ffb967393a3eb8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5337a574ea6c177f4ffb967393a3eb8">&#9670;&nbsp;</a></span>get_options() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">PrintOptions cpp20print::printing::detail::get_options </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Overloaded function; if T&amp; is not PrintOptions&amp; return default options. </p>

</div>
</div>
<a id="aeee5a1be79dd7c9cb87c7f6aa842a89a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeee5a1be79dd7c9cb87c7f6aa842a89a">&#9670;&nbsp;</a></span>print()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void cpp20print::printing::print </td>
          <td>(</td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Prints any object. </p>
<p>Use like print("text1", "text2", string, object). Use PrintOptions to set options, e.g., print(string1, string2, PrintOptions {.seperator=" ", .end="\n"}) </p>

</div>
</div>
<a id="afe9466890a34c5498386a55281bf30a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afe9466890a34c5498386a55281bf30a7">&#9670;&nbsp;</a></span>print_element()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void print_element </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname"><em>options</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>t</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prints a single object. Default for objects that are not lists ("atoms"). </p>
<p>Prints a single object that is a list.</p>
<p>Prints a single object that is a pair.</p>
<p>Lists are all iterable objects, except strings. </p>

</div>
</div>
<a id="a84aa02fb20f80f38d0b6b7418094c9a3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a84aa02fb20f80f38d0b6b7418094c9a3">&#9670;&nbsp;</a></span>print_recursive() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void cpp20print::printing::detail::print_recursive </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname"><em>options</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>t</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prints last element if only one left after recursion. </p>

</div>
</div>
<a id="a36591a53d09fc0c1ed0b14ce88e3df1a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a36591a53d09fc0c1ed0b14ce88e3df1a">&#9670;&nbsp;</a></span>print_recursive() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void cpp20print::printing::detail::print_recursive </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname"><em>options</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prints first argument. </p>
<p>Calls itself recursively with first argument removed. If only one arguement left calls overloaded function to print last element without seperator. </p>

</div>
</div>
<a id="aa6b8a6af7bd70b1b05875ba379ede13c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa6b8a6af7bd70b1b05875ba379ede13c">&#9670;&nbsp;</a></span>print_recursive() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void cpp20print::printing::detail::print_recursive </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname"><em>options</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Removes PrintOptions&amp; from args, and prints last element. </p>
<p>(At this point print options have already been parsed and can be discarded) </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
